#include <AT898252.h>

void Strobe();
void ClockIn();
void PutFrame();
void Put18Bit(unsigned char i);
void rawModus();

unsigned char frame[20];


void initSpi(void)
{
	//SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0); //Enable SPI, SPI in Slave Mode	Teiler 16
	SPCR = 0x44;
}

unsigned char getByteSpi(void)
{
	while(!(SPSR & 0x80));
	return SPDR;
}


void main()
{
	unsigned char i=0;
	initSpi();
	P3_5 = 0;
	P1_2 = 0;

	while(1){

		i=getByteSpi();
		if(i =='r')
			rawModus();
	}
}

void rawModus()
{
	unsigned char i;
	for(i=2;i<18+2;i++){
		frame[i]=getByteSpi();
	}
	frame[0]=0;
	frame[1]=0;
	PutFrame();
}

void PutFrame()
{
	unsigned char i;
	for(i=8;i>0;i--){
		Put18Bit(i);
		ClockIn();
	}
	Strobe();
}

void Put18Bit(unsigned char i)
{
	i--;
	i = 1<<i;
	P2_0 = frame[2] & i;
	P2_1 = frame[3] & i;
	P2_2 = frame[4] & i;
	P2_3 = frame[5] & i;
	P2_4 = frame[6] & i;
	P2_5 = frame[7] & i;
	P2_6 = frame[8] & i;
	P2_7 = frame[9] & i;

	P0_0 = frame[10] & i;
	P0_1 = frame[11] & i;
	P0_2 = frame[12] & i;
	P0_3 = frame[13] & i;
	P0_4 = frame[14] & i;
	P0_5 = frame[15] & i;
	P0_6 = frame[16] & i;
	P0_7 = frame[17] & i;

	P1_0 = frame[18] & i;
	P1_1 = frame[19] & i;

}

void Strobe()
{
	P1_2 = 1;
	P1_2 = 0;
}

void ClockIn()
{
	P3_5 = 1;
	P3_5 = 0;
}
