#include <stdio.h>
#include "main.h"
#include "blinkenled.h"

void blinkendata(unsigned char * packet,unsigned int len)
{

	//printf("Got a %u bytes long BLP packet..",len);
	if(packet[0]==0xDE &&packet[1]==0xAD &&packet[2]==0xBE &&packet[3]==0xEF){
		//printf("valid\n");
		unsigned char temp=0;
		unsigned char i,j;
		
		blinken_sendByte('r');
		for(i=0;i<18;i++){
			unsigned char pos = i;
			for(j=0;j<8;j++){
				temp>>=1;
				temp |= packet[BLINKENLED_DATASTART+pos]<<7;
				pos+=18;
			}
			blinken_sendByte(temp);
		}
	}
}

void blinken_init(void)
{

	//ySPI_DDR &= ~(1<<SPI_MISO);
	SPI_PORT &= ~(1<<SPI_SCK);
	SPI_DDR |= (1<<SPI_SCK);
	SPI_DDR |= (1<<SPI_MOSI);
	//SPI_Write |= (1<<SPI_SS);
	
	//SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<CPHA); //Enable SPI, SPI in Master Mode	Teiler 16
	//(1<<SPR0)|
	//SPSR = (0<<SPI2X);
}

void blinken_sendByte(unsigned char c)
{
	//SPDR= c;
	//while(!(SPSR & (1<<SPIF)));
	unsigned char i;
	for(i=0;i<8;i++){
	
		SPI_PORT |= (1<<SPI_SCK);
		if(c & (1<<(7-i)))
			SPI_PORT |= (1<<SPI_MOSI);
		else
			SPI_PORT &= ~(1<<SPI_MOSI);
		SPI_PORT &= ~(1<<SPI_SCK);
		nop();
		nop();
		nop();
		nop();
	}
}

/*unsigned char blinken_readByte(void)
{
	SPDR=0xff;
	while(!(SPSR & (1<<SPIF)));
	return SPDR;
}*/
