
#ifndef _UDP_H
#define _UDP_H

#define UDP_OFFSET				0x22

struct UDP_Header	{
	unsigned int 	UDP_SrcPort;	//der Quellport fr das Packet
	unsigned int 	UDP_DestPort;	//der Zielport fr das Packet
	unsigned int	UDP_PacketLen;	//Packetlnge incl. Header
	unsigned int	UDP_CheckSum;
};

#define	UDP_SRCPORT				UDP_OFFSET+0x00	//der Quellport fr das Packet
#define	UDP_DESTPORT			UDP_OFFSET+0x02	//der Zielport fr das Packet
#define	UDP_PACKETLEN			UDP_OFFSET+0x04//Packetlnge incl. Header
#define	UDP_CHECKSUM			UDP_OFFSET+0x06
#define UDP_DATASTART			UDP_OFFSET+0x08
#define UDP_HEADERLEN			0x08

#endif 
